"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var _zeromq = _interopRequireDefault(require("zeromq"));

var _configureStore = _interopRequireDefault(require("./store/configureStore"));

var zmqServices = _interopRequireWildcard(require("./actions/zmqServices"));

var _zmqServices2 = require("./selectors/zmqServices");

var _configYml = _interopRequireDefault(require("config-yml"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var init_services = _configYml["default"].discovery.services;

var zmq_in = _zeromq["default"].socket('rep');

var zmq_out = _zeromq["default"].socket('pub');

var url_in = "tcp://*:" + _configYml["default"].discovery.input.port;
var url_out = "tcp://*:" + _configYml["default"].discovery.publish.port;
console.log('Discovery is waiting for connection at "' + url_in);
zmq_in.bindSync(url_in);
zmq_out.bindSync(url_out);

if (init_services !== undefined) {
  console.log("Default services: ");
  init_services.forEach(function (element) {
    console.log(element);

    _configureStore["default"].dispatch(zmqServices.onZeroMQServiceAdd(element));

    zmq_out.send(JSON.stringify({
      action: "add",
      zmq: element
    }));
  });
}

zmq_in.on('message', function (a, n, u, s) {
  var action = a.toString();
  var name = n.toString();
  var url = u.toString();
  var src = s.toString();

  if (action === "add") {
    if (name.length !== 0) {
      var out = {
        name: name,
        url: url,
        src: src
      };

      _configureStore["default"].dispatch(zmqServices.onZeroMQServiceAdd(out)); // TODO to put it to store


      zmq_out.send(JSON.stringify({
        action: action,
        zmq: out
      }));
    }

    zmq_in.send(JSON.stringify({
      rc: 0,
      msg: "OK"
    }));
  } else if (action === "rm") {
    if (name.length !== 0) {
      var _out = {
        name: name,
        url: url,
        src: src
      };

      _configureStore["default"].dispatch(zmqServices.onZeroMQServiceRemove(_out)); // TODO to put it to store


      zmq_out.send(JSON.stringify({
        action: action,
        zmq: _out
      }));
    }

    zmq_in.send(JSON.stringify({
      rc: 0,
      msg: "OK"
    }));
  } else if (action === "get") {
    // TODO to put it to store
    zmq_in.send(JSON.stringify({
      rc: 0,
      msg: "OK",
      data: (0, _zmqServices2.getZeroMQServices)(_configureStore["default"].getState()).services
    }));
  }
});
process.on('SIGINT', function () {
  console.log();
  console.log("Exiting ...");
  zmq_in.unbind(url_in);
  zmq_out.unbind(url_out);
  process.exit(1);
});