"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onZeroMQSubCleanup = exports.onZeroMQSubRemoveByFullName = exports.onZeroMQSubRemoveByGroup = exports.onZeroMQSubAdd = exports.onZeroMQRemove = exports.onZeroMQAdd = void 0;

var _zeromq = _interopRequireDefault(require("zeromq"));

var _rxjs = _interopRequireDefault(require("rxjs"));

var zmqBroker = _interopRequireWildcard(require("../actions/zmqBroker"));

var appInfo = _interopRequireWildcard(require("../actions/appInfo"));

var _zmqBroker2 = require("../actionTypes/zmqBroker");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var onZeroMQAdd = function onZeroMQAdd(data, wss) {
  return function (dispatch, getState) {
    var state = getState(); // TODO If we already have that name

    var zmq_sock = _zeromq["default"].socket("sub");

    zmq_sock.connect(data.url);
    zmq_sock.subscribe("");
    dispatch({
      type: _zmqBroker2.ON_ZMQ_BROKER_ADD,
      payload: data,
      zmq: zmq_sock
    });
    zmq_sock.on("message", function (sub, name, d) {
      //    console.log("zmq : '" + sub.toString() + "' '" + name.toString() + "'");
      var state = getState();
      var sub_str = sub.toString();
      var src = sub_str.substring(0, sub_str.indexOf(":"));
      if (src === "") src = "obmon";
      var n = src + "|" + data.name + "|" + name.toString(); // FIXME IF ZMQ service is removed

      if (state.zmqBroker.zmqs$[n] === undefined) {
        dispatch(zmqBroker.onZeroMQSubAdd({
          name: data.name,
          sub: name.toString(),
          src: src.toString()
        }));
        dispatch(appInfo.onZeroMQServiceAdd({
          name: data.name,
          sub: name.toString(),
          src: src.toString()
        }, wss));
      }

      if (state.zmqBroker.zmqs$[n] !== undefined) {
        var r$ = state.zmqBroker.zmqs$[n].zmq$;

        if (r$ !== undefined) {
          var out = {
            name: data.name,
            sub: name.toString(),
            data: JSON.parse(d.toString())
          };
          r$.next(out);
        }
      }
    });
  };
};

exports.onZeroMQAdd = onZeroMQAdd;

var onZeroMQRemove = function onZeroMQRemove(data, wss) {
  return function (dispatch, getState) {
    var state = getState();

    if (state.zmqBroker.zmqs === undefined) {
      return;
    }

    var z = state.zmqBroker.zmqs[data.name];

    if (z === undefined) {
      return;
    }

    z.zmq.disconnect(z.url);
    delete z.zmq;
    dispatch(appInfo.onZeroMQServiceRemove({
      name: data.name,
      sub: ""
    }, wss));
    dispatch({
      type: _zmqBroker2.ON_ZMQ_BROKER_REMOVE,
      payload: data
    });
  };
};

exports.onZeroMQRemove = onZeroMQRemove;

var onZeroMQSubAdd = function onZeroMQSubAdd(data) {
  return function (dispatch, getState) {
    var state = getState();
    dispatch({
      type: _zmqBroker2.ON_ZMQ_BROKER_ZMQSUB_ADD,
      payload: data,
      zmq$: new _rxjs["default"].ReplaySubject(process.env.ZMQ_CACHE || 1)
    });
  };
};

exports.onZeroMQSubAdd = onZeroMQSubAdd;

var onZeroMQSubRemoveByGroup = function onZeroMQSubRemoveByGroup(data) {
  return function (dispatch, getState) {
    var state = getState();
    dispatch({
      type: _zmqBroker2.ON_ZMQ_BROKER_ZMQSUB_REMOVE_BY_GROUP,
      payload: data
    });
  };
};

exports.onZeroMQSubRemoveByGroup = onZeroMQSubRemoveByGroup;

var onZeroMQSubRemoveByFullName = function onZeroMQSubRemoveByFullName(data) {
  return function (dispatch, getState) {
    var state = getState();
    dispatch({
      type: _zmqBroker2.ON_ZMQ_BROKER_ZMQSUB_REMOVE_BY_FULLNAME,
      payload: data
    });
  };
};

exports.onZeroMQSubRemoveByFullName = onZeroMQSubRemoveByFullName;

var onZeroMQSubCleanup = function onZeroMQSubCleanup(timeout, wss) {
  return function (dispatch, getState) {
    var d = new Date();
    d.setSeconds(d.getSeconds() - timeout);
    var state = getState(); // console.log("Checking cleanup ...");

    for (var key in state.zmqBroker.zmqs$) {
      var obj = state.zmqBroker.zmqs$[key]; // console.log(key);
      // console.log(obj.zmq$._events.length);

      if (obj.zmq$._events.length > 0) {
        // console.log(d.getTime());
        // console.log(obj.zmq$._events[0].time);
        var diff = d.getTime() - obj.zmq$._events[0].time; // console.log("key : " + key + " diff : " + diff);


        if (diff > 0) {
          var res = key.split("|");
          console.log("Removing inactive service (more then " + timeout + " sec) : name=" + res[1] + " sub=" + res[2] + " src=" + res[0] + "...");
          dispatch(zmqBroker.onZeroMQSubRemoveByFullName({
            name: key
          }));
          dispatch(appInfo.onZeroMQServiceRemoveSingle({
            name: res[1],
            sub: res[2],
            src: res[0]
          }, wss)); // sending empty data to signal frontend that service is not active anymore

          wss.broadcast(JSON.stringify({
            type: "zmq",
            data: [],
            name: res[1],
            sub: res[2],
            src: res[0]
          }));
        }
      }
    }
  };
};

exports.onZeroMQSubCleanup = onZeroMQSubCleanup;