"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var _child_process = require("child_process");

var _package = require("../../package.json");

var _configYml = _interopRequireDefault(require("config-yml"));

var _server = _interopRequireDefault(require("./server"));

var _zeromq = _interopRequireDefault(require("zeromq"));

var _configureStore = _interopRequireDefault(require("./store/configureStore"));

var appInfo = _interopRequireWildcard(require("./actions/appInfo"));

var zmqBroker = _interopRequireWildcard(require("./actions/zmqBroker"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

console.log(_package.name + " " + _package.version);
var url_init = "tcp://" + _configYml["default"].discovery.input.host + ":" + _configYml["default"].discovery.input.port;
var url_publisher = "tcp://" + _configYml["default"].discovery.publish.host + ":" + _configYml["default"].discovery.publish.port;

var zmq_discovery_init = _zeromq["default"].socket("req");

var zmq_discovery = _zeromq["default"].socket("sub");

if (url_init !== undefined && url_init !== 0) {
  console.log("ZMQ connected to " + url_init);
  zmq_discovery_init.connect(url_init);
  zmq_discovery_init.send(["get", "", "", ""]);
  zmq_discovery_init.on("message", function (data) {
    var dataObj = JSON.parse(data.toString());
    dataObj.data.forEach(function (item) {
      console.log(item);

      _configureStore["default"].dispatch(zmqBroker.onZeroMQAdd(item, _server["default"].wss));
    });
    zmq_discovery_init.disconnect(url_init);
  });
}

if (url_publisher !== undefined && url_publisher.length !== 0) {
  console.log("ZMQ connected to " + url_publisher + " sub='" + _configYml["default"].discovery.publish.sub + "'");
  zmq_discovery.connect(url_publisher);
  zmq_discovery.subscribe(_configYml["default"].discovery.publish.sub);
  zmq_discovery.on("message", function (data) {
    var dataObj = JSON.parse(data.toString());
    console.log(dataObj);

    if (dataObj.action === "add") {
      _configureStore["default"].dispatch(zmqBroker.onZeroMQAdd(dataObj.zmq, _server["default"].wss));
    } else if (dataObj.action === "rm") {
      _configureStore["default"].dispatch(zmqBroker.onZeroMQSubRemoveByGroup(dataObj.zmq));

      _configureStore["default"].dispatch(zmqBroker.onZeroMQRemove(dataObj.zmq, _server["default"].wss));
    } else {
      console.log("Error : [zmq_discovery] unknown type=" + dataObj.type);
    }
  });
}

var myVar = setInterval(myTimer, process.env.ZMQ2WS_INACTIVITY_CHECK_MSEC || 60 * 1000
/** 1 min */
);

function myTimer() {
  _configureStore["default"].dispatch(zmqBroker.onZeroMQSubCleanup(process.env.ZMQ2WS_INACTIVITY_TIMEOUT_SEC || 3600
  /** 1 hour */
  , _server["default"].wss));
}

_server["default"].post("/api/salsa/cmd", function (req, res) {
  var url = req.body.url; // tcp://localhost:41000

  var cmd = req.body.cmd; // WORKER_COUNT

  var arg = req.body.arg; // WORKER_COUNT

  var zmq_dealer = _zeromq["default"].socket("dealer");

  console.log("Doing cmd '" + cmd + "' to '" + url + "' ...");
  zmq_dealer.connect(url);
  zmq_dealer.send(["AUTH"]);
  zmq_dealer.on("message", function (empty, c, r) {
    var c_str = c.toString();
    var r_str = r.toString(); // console.log("/api/salsa/cmd : c='" + c_str + "' r='" + r_str + "'");

    if (c_str === "AUTH" && r_str === "OK") {
      console.log("AUTH is OK");

      if (cmd !== "AUTH") {
        zmq_dealer.send([cmd, arg]);
      }
    } else if (c_str === cmd && r_str !== "FAILED") {
      zmq_dealer.disconnect(url);
      res.status(200).send({
        data: r_str
      });
    } else {
      zmq_dealer.disconnect(url);
      res.status(403);
      if (cmd === "AUTH") res.send({
        err: "Problem with AUTH !!!"
      });else res.send({
        err: "Problem with executing command '" + cmd + "' !!!"
      });
    }
  });
});

_server["default"].post("/api/salsa/exec", function (req, res) {
  var _req$body = req.body,
      cmd = _req$body.cmd,
      uid = _req$body.uid,
      gid = _req$body.gid;

  if (/^salsa-feeder -s tcp:\/\/.*:([1-9]|[1-9]\d{1,3}|[1-5]\d{4}|6[0-4]\d{3}|65[0-4]\d{2}|655[0-2]\d|6553[0-5]) -t \".*\"$/.test(cmd) === false) {
    res.status(400).json({
      status: 127
    });
    return;
  }

  (0, _child_process.exec)("".concat(cmd, " --batch"), {
    uid: parseInt(uid),
    gid: parseInt(gid)
  }, function (err, stdout) {
    if (stdout) {
      res.status(200).json({
        status: 0
      });
    }

    if (err) {
      res.status(400).json({
        status: "".concat(err.code)
      });
    }
  });
});

_configureStore["default"].dispatch(appInfo.onAppStart({
  name: _package.name,
  version: _package.version
}));

_server["default"].server.listen(_server["default"].get("port"), function () {
  return console.log("Http" + (_configYml["default"].zmq2ws.ssl.enabled ? "s" : "") + " is listening on port " + _server["default"].get("port"));
});

process.on("SIGINT", function () {
  console.log();
  console.log("Exiting ...");
  zmq_discovery.unsubscribe(_configYml["default"].discovery.publish.sub);
  zmq_discovery.unbind(url_publisher);
  process.exit(1);
});