"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = reducer;

var _ws = _interopRequireDefault(require("ws"));

var _wsBroker = require("../actionTypes/wsBroker");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// init state
var initialState = {
  wsClients: {}
}; // reducer

function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case _wsBroker.ON_WS_BROKER_SUB:
      {
        // TODO check if subscribed already
        var clients = _objectSpread({}, state.wsClients);

        if (clients[action.ws.id] !== undefined) {
          if (clients[action.ws.id][action.name] !== undefined) {
            clients[action.ws.id][action.name].unsubscribe();
            delete clients[action.ws.id][action.name];
          }
        } else {
          clients[action.ws.id] = {};
        }

        clients[action.ws.id][action.name] = action.zmqUnSub;
        return _objectSpread({}, state, {
          wsClients: clients
        });
      }

    case _wsBroker.ON_WS_BROKER_UNSUB:
      {
        if (state.wsClients[action.ws.id] === undefined) {
          return state;
        }

        var _clients = _objectSpread({}, state.wsClients);

        if (action.name === "") {
          for (var o in _clients[action.ws.id]) {
            if (_clients[action.ws.id].hasOwnProperty(o)) {
              // TODO move it to action
              _clients[action.ws.id][o].unsubscribe();

              delete _clients[action.ws.id][o];
            }
          }
        } else {
          if (_clients[action.ws.id][action.name] !== undefined) {
            // TODO move it to action
            _clients[action.ws.id][action.name].unsubscribe();

            delete _clients[action.ws.id][action.name];
          }
        }

        if (Object.keys(_clients[action.ws.id]).length === 0 && _clients[action.ws.id].constructor === Object) {
          delete _clients[action.ws.id];
        }

        return _objectSpread({}, state, {
          wsClients: _clients
        });
      }

    default:
      return state;
  }
}