"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = reducer;

var _zmqBroker = require("../actionTypes/zmqBroker");

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var initialState = {
  zmqs: {},
  zmqs$: {}
};

function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case _zmqBroker.ON_ZMQ_BROKER_ADD:
      // console.log(action.zmq);
      return _objectSpread({}, state, {
        zmqs: _objectSpread({}, state.zmqs, _defineProperty({}, action.payload.name, {
          zmq: action.zmq,
          url: action.payload.url
        }))
      });

    case _zmqBroker.ON_ZMQ_BROKER_REMOVE:
      return _objectSpread({}, state, {
        zmqs: _objectSpread({}, state.zmqs, _defineProperty({}, action.payload.name, undefined))
      });

    case _zmqBroker.ON_ZMQ_BROKER_ZMQSUB_ADD:
      return _objectSpread({}, state, {
        zmqs$: _objectSpread({}, state.zmqs$, _defineProperty({}, action.payload.src + "|" + action.payload.name + "|" + action.payload.sub, {
          zmq$: action.zmq$,
          name: action.payload.name
        }))
      });

    case _zmqBroker.ON_ZMQ_BROKER_ZMQSUB_REMOVE_BY_GROUP:
      var clone = _extends({}, state.zmqs$);

      for (var p in clone) {
        if (clone.hasOwnProperty(p)) {
          if (p.startsWith(action.payload.src + "|" + action.payload.name)) {
            delete clone[p];
          }
        }
      }

      return _objectSpread({}, state, {
        zmqs$: clone
      });

    case _zmqBroker.ON_ZMQ_BROKER_ZMQSUB_REMOVE_BY_FULLNAME:
      var clone_byname = _extends({}, state.zmqs$);

      for (var p in clone_byname) {
        if (clone_byname.hasOwnProperty(p)) {
          if (p === action.payload.name) {
            delete clone_byname[p];
          }
        }
      }

      return _objectSpread({}, state, {
        zmqs$: clone_byname
      });

    default:
      return state;
  }
}