let fs = require('fs');
let readline = require('readline');

let cnsl = readline.createInterface({
    input: process.stdin,
    output: process.stdout
});

if (!fs.existsSync('./test/config/config.js')) {
    console.log("Create config/config.js from config/config.js.example first !!!")
    process.exit(1);
}

let cfg = require('./config/config');
module.exports = cfg;

let ipa = require("../node-ipa");
ipa.create(cfg.ldap.url, cfg.ldap.domain);

let user = {
    username: '',
    password: ''
};

function hiddenPsd(query, callback) {
    let stdin = process.openStdin();
    process.stdin.on("data", function(char) {
        char = char + "";
        switch (char) {
            case "\n":
            case "\r":
            case "\u0004":
                stdin.pause();
                break;
            default:
                process.stdout.write("\033[2K\033[200D" + query + "");
                break;
        }
    });

    cnsl.question(query, function(value) {
        cnsl.history = cnsl.history.slice(1);
        callback(value);
    });
}


cnsl.question("Login: ", function(username) {
    user.username = username;

    hiddenPsd("Password: ", function(password) {
        user.password = password;

        ipa.login(user.username, user.password, function(status, profile) {
            console.log("Status: " + status);
            console.log("Profile: " + profile);
        });
    });
});
